import { MongoDbProjection } from './mongoDbProjection';
import { MongoDbSort } from "./mongoDbSort";
import { GraphQLResolveInfo, GraphQLFieldResolver, GraphQLObjectType } from 'graphql';
export interface QueryCallback<TSource, TContext> {
    (filter: object, projection: MongoDbProjection, options: MongoDbOptions, source: TSource, args: {
        [argName: string]: any;
    }, context: TContext, info: GraphQLResolveInfo): Promise<any>;
}
export interface QueryOptions {
    differentOutputType: boolean;
}
export interface MongoDbOptions {
    sort?: MongoDbSort;
    limit?: number;
    skip?: number;
    projection?: MongoDbProjection;
}
export declare function getMongoDbQueryResolver<TSource, TContext>(graphQLType: GraphQLObjectType, queryCallback: QueryCallback<TSource, TContext>, queryOptions?: QueryOptions): GraphQLFieldResolver<TSource, TContext>;
export declare function getGraphQLQueryArgs(graphQLType: GraphQLObjectType): object;
